On this page
No Headings
Last updated: June 18, 2026
Enable 3D Secure for advanced credit and debit cards. This integration uses Orders API.
Info: PayPal handles 3D Secure authentication for standard payment integrations. No changes are required for standard integrations.
See PSD2
You can use Postman to explore and test PayPal APIs. Learn more in our Postman guide.
Use the following code to request either SCA_ALWAYS or SCA_WHEN_REQUIRED as a verification attribute for the card object.
SCA_ALWAYS trigger 3D Secure for every transaction, regardless of SCA requirements.SCA_WHEN_REQUIRED returns a 3D Secure contingency when it is a mandate in the region where you operate. This is the default when neither parameter is explicitly passed."request": {
"method": "POST",
"path": "v2/checkout/orders/5O190127TN364715T/authorize",
"headers": {
"PayPal-Request-Id": "7b92603e-77ed-4896-8e78-5dea2050476a",
"Authorization: Bearer <Access-Token>"
},
"body": {
"payment_source": {
"card": {
"number": "4111111111111111",
"expiry": "2010-02",
"name": "John Doe",
"billing_address": {
"address_line_1": "2211 N First Street",
"address_line_2": "17.3.160",
"admin_area_1": "CA",
"admin_area_2": "San Jose",
"postal_code": "95131",
"country_code": "US"
},
"attributes": {
"verification": {
"method": "SCA_WHEN_REQUIRED"
}
}
}
}
}
},| Request | Result |
|---|---|
| Single-step payment request | HTTP 201 Created |
| Multi-step payment request | HTTP 422 Unprocessable Entity |
| Confirm order request | HTTP 200 OK |
The merchant needs to redirect the payer back to PayPal to complete 3D Secure authentication.
To trigger the authentication:
"rel": "payer-action" HATEOAS link returned as part of the response before authorizing or capturing the order."redirect_uri" to the payer-action URL so that PayPal returns the payer to the merchant's checkout page after they complete 3D Secure authentication.https://example.com/webapp/myshop?action=verify&flow=3ds&cart_id=ORDER-ID&redirect_uri=MERCHANT-LANDING-PAGE
"request": {
"method": "GET",
"path": "v2/checkout/orders/5O190127TN364715T?fields=payment_source",
"headers": {
"Authorization: Bearer <Access-Token>"
}
},After the 3D Secure contingency is thrown during the create order response, and contingency is resolved by the buyer, the merchant or partner must invoke the authorize order and capture order endpoints with an empty payload to complete the transaction.
After the 3D Secure contingency is thrown during the authorize order and capture order response and contingency is resolved by the buyer, the merchant or partner must invoke the authorize order and capture order endpoints again with an empty payload to complete the transaction.